if not _G.LibStub then print("HideBlizzard requires LibStub.") return end

local HideBlizzard = HideBlizzard or _G.CreateFrame("Frame")
assert(_G.HideBlizzard, "HideBlizzard doesn't seem to exist!")

local AceConfig = _G.LibStub("AceConfig-3.0")
local AceEvent = _G.LibStub("AceEvent-3.0")

_G._VERSION = GetAddOnMetadata("HideBlizzard", "Version")

local defaults = {
	profile = {
		modules = {
			["ActionBar"] = nil,
			["Buttons"] = nil,
			["Pet"] = nil,
			["Player"] = nil,
			["SpecialFrames"] = nil,
			["Target"] = nil,
			["Vehicle"] = nil,
		},
	},
}

function HideBlizzard:OnInitialize()
	self:RunInitTasks()
	
	
	
--[[
	self:RegisterEvent("PLAYER_REGEN_DISABLED", function()
		if InterfaceOptionsFrame:IsVisible() then
			self:Print("|cff40bbffHideBlizzard|r is closing the options window since you are currently in combat")
			InterfaceOptionsFrame:Hide()
			GameMenu:Hide()
		end
	end)
]]
end

function HideBlizzard:RunInitTasks()
	HideBlizzardDB = HideBlizzardDB or {}
	if (type(HideBlizzardDB) ~= "table") then print("HideBlizzard's database has been malformed.") return end

	if not HideBlizzardDB.version then
		HideBlizzardDB.version = _G._VERSION
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------------------------

function HideBlizzard:UpdateView()
	for k,v in self:IterateModules() do
		if self:GetModuleEnabled(k) and not v:IsEnabled() then
			self:EnableModule(k)
		elseif not self:GetModuleEnabled(k) and v:IsEnabled() then
			self:DisableModule(k)
		end
		if (type(v.UpdateView) == "function") then
			v:UpdateView()
		end
	end
end

function HideBlizzard:GetModuleEnabled(module)
	return self.db.profile.modules[module]
end

function HideBlizzard:SetModuleEnabled(module, value)
	local old = HideBlizzard.db.profile.modules[module]
	HideBlizzard.db.profile.modules[module] = value
	if old ~= value then
		if value then
			HideBlizzard:EnableModule(module)
		else
			HideBlizzard:DisableModule(module)
		end
	end
end